/**
 * @version 3.5 2004-05-04
 * @author Gonzalo Ojeda 9821018-0
 */

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.net.*;
import java.applet.*;


/**
 * Esta clase corresponde a la clase base de la presente tarea, la que define 
 * al JFrame de trabajo, el cual a su vez contendra un JPanel con los botones
 * de figuras y operaciones y otro JPanel donde se dibujaran las figuras 
 * (elipses, rectangulos y lneas).
 */
public class Editor extends JApplet
{  
  /**
  * Funcion <b>Init</b> de todo el programa, la encargada de crear el JFrame 
  * principal y setear ciertos parametros, en primer lugar se capturan los 
  * parametros entregados desde la pagina html que contiene al applet.
  */
  public void init()
  {  
    // urlString  corresponde a la URL en frameDest.
    // frameDest  corresponde al destino para abrir la direccion urlString
    // isFlotante indica si habra un applet flotante o no.
    String urlString = getParameter("URL");
    final String frameDest = getParameter("Frame");
    String isFlotante = getParameter("Flotante");

    // panel que contiene los botones y la zona de dibujo
    Container contentPane = getContentPane();
    EditorPanel panel = new EditorPanel();
    contentPane.add(panel);
    // probar la url
    try
    {  
      final URL url = new URL(urlString);

      // hacer un bot on para el link
      linkPanel = new JPanel();
      JButton linkButton = new JButton("Abrir Link(" + urlString + ")");
      linkPanel.add(linkButton);
      contentPane.add(linkPanel, BorderLayout.NORTH);
      // presionar el bot on implica que se abre la URL en el frame "down"
      linkButton.addActionListener(new 
       ActionListener()
       {
          public void actionPerformed(ActionEvent event)
          {
            AppletContext context = getAppletContext();
            context.showDocument(url, frameDest);
          }
       });
      } 
      // si la url fue mal creada se captura la excepcion
      catch (MalformedURLException exception) 
        { exception.printStackTrace(); }
      // definiciones en caso de tratarse de un frame flotante
      if ("true".equals(isFlotante))
      {
        frame = new JFrame();
        frame.setTitle("Editor");
        frame.setSize(ANCHO, ALTO);
        frame.getContentPane().add(new EditorPanel());
        // se define un bot on en el applet incrustado en la web para mostrar u
        //ocultar el popup
        JButton popupButton = new JButton ("PopUp");
        linkPanel.add(popupButton);
        popupButton.addActionListener(new
         ActionListener()
         {
           public void actionPerformed(ActionEvent evt)
           {  
             if (frame.isVisible()) frame.setVisible(false);
             else frame.show();
           }
         });
        // el frame parte visible por defecto
        frame.show();
      }
    }
    // linkPanel es el panel donde va el bot on para abrir el link y otro para
    // mostrar u ocultar el popup
    private JPanel linkPanel;
    private JFrame frame;              // frame es la ventana del popup
    private final int ANCHO = 800;
    private final int ALTO = 400;
}

