/**
   @version 3.3 2004-05-4
   @author Gonzalo Ojeda Figueroa
*/

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 *El Panel que crea los botones y la zone de trabajo, escencialmente el mismo
 *de la tarea anterior
 */
public class EditorPanel extends JPanel
{  
  public EditorPanel()
  {  
    setLayout(new BorderLayout());
    
    JButton rectButton = new JButton ("Rectangulo");
    JButton elipButton = new JButton ("Elipse");
    JButton linButton = new JButton ("Linea");
    // Botones para las operaciones sobre las Figuras.
    JButton rotButton = new JButton ("Rotar");
    JButton escButton = new JButton ("Escalar");
    JButton trasButton = new JButton ("Trasladar");
    // Boton que limpia la zona de dibujo.
    JButton clearButton = new JButton ("Limpiar");
    // Crear un Action Listener para el boton que limpia la zona de dibujo, y
    // asigna ese y asigna este ActionListener al boton para limpiar la zona de
    // dibujo.
    ActionListener listener = new CleanListener();
    clearButton.addActionListener(listener);
    // Panel donde se ubicaran los Botones.
    JPanel buttonPanel = new JPanel();
    buttonPanel.setLayout(new BorderLayout());
    // Panel superior que ira a la izquierda, donde iran los botones de formas
    // tambin se lo habilita para poder usar subsecciones de l.
    JPanel northPanel = new JPanel ();
    northPanel.setLayout(new BorderLayout());
    // se agregan los botones de figura a este JPanel, en distintas zonas.
    northPanel.add(rectButton, BorderLayout.NORTH);
    northPanel.add(elipButton, BorderLayout.CENTER);
    northPanel.add(linButton, BorderLayout.SOUTH);
    // Un panel inferior donde iran las opciones
    JPanel southPanel = new JPanel();
    southPanel.setLayout(new BorderLayout());
    // se agregan los botones con las opciones
    southPanel.add(rotButton, BorderLayout.NORTH);
    southPanel.add(escButton, BorderLayout.CENTER);
    southPanel.add(trasButton, BorderLayout.SOUTH);
    // agregar al panel de botones, los dos paneles antes creados con botones
    // para figuras y opciones respectivamente, ademas de el boton para limpiar.
    buttonPanel.add(northPanel, BorderLayout.NORTH);
    buttonPanel.add(clearButton, BorderLayout.CENTER);
    buttonPanel.add(southPanel, BorderLayout.SOUTH);
    add(buttonPanel, BorderLayout.WEST);
    fPanel = new FigPanel(rectButton, elipButton, linButton, rotButton, 
    escButton, trasButton);
    add(fPanel, BorderLayout.CENTER);
  }
 /**
  * Clase interna para responder a los click en el boton que limpia la zona de
  * dibujo. Al realizarse un click en este boton, se llama a un mtodo definido
  * en la clase <b>FigPanel</b>, el cual borra la zona de dibujo.
  */
  private class CleanListener implements ActionListener
  {
   /**
    * Mtodo que responde a la accion de presionar el boton de limpiado, invoca
    * al mtodo clearShapes() definido en la clase <b>FigPanel</b>.
    */
    public void actionPerformed(ActionEvent e)
    {
      fPanel.clearShapes();
    }
  }
  
  private FigPanel fPanel;
}


